#ifndef __FSAttributed_h__
#define __FSAttributed_h__

#include "fs/FSResult.H"

/**
 * This class provides an interface to query and set attributes of the
 * filesystem and their objects.
 */
class FSAttributed
{
public:
  virtual ~FSAttributed() {}
  virtual FSResult attribute_count(int &count) = 0;
  virtual FSResult attribute_name(unsigned int n, const char *&name) = 0;
  virtual FSResult attribute_description(unsigned int n, const char *&description) = 0;
  virtual FSResult set_attribute(const char* name, const char *val) = 0;
  virtual FSResult get_attribute(const char* name, char *val, int& size) = 0;
};

#endif // __FSAttributed_h__
