#ifndef __FSObjImpl_h__
#define __FSObjImpl_h__

#include "FS.H"
//#include "fs/FSResult.H"

/**
 * Interface for the implementation of a filesystem specific object.
 */
class FSObjImpl
{
protected:
  /** number of the current references */
  int reference_count;
  /** pointer to the interface of the filesystem */
  FS *fs;
public:
  FSObjImpl(FS *filesystem) : reference_count(0), fs(filesystem) {}
  virtual ~FSObjImpl() {}
  
  FS* filesystem() { return fs; }

  /**
   * Creates a new reference for this file.
   */
  void new_reference () { reference_count++; }


  /**
   * Deletes a reference for this file.
   */
  void release_reference () { if ((--reference_count) == 0) delete this; }
};

#endif // __FSDirImpl_h__



  

