#ifndef __Unix_Device_Identification_h__
#define __Unix_Device_Identification_h__

// This unix file device layer is used for the device identification.
// A unix device file is identified by its filename. This name can be
// set with constructor and cannot be changed afterwards. To work with
// different unix file devices different identifications have to be used.
class UnixDeviceIdentification
{
  const char* devname;       // the name of the file that should look like a device
public:
  UnixDeviceIdentification (const char* dn) : devname (dn) {}
  const char* name () { return devname; }
};

#endif /* __Unix_Device_Identification_h__ */
