#ifndef __Unix_Device_Informer_h__
#define __Unix_Device_Informer_h__

#include "fs/device/UnixDeviceUser.H"

// This class extends the UnixDeviceUser class by adding instance variables
// that inform clients about important device characteristics.
// The information can be either set explicitly with 'setup' or detected
// with the 'detect' method.
class UnixDeviceInformer : public UnixDeviceUser
{
  unsigned long size;      // no of bytes in the file, 0L if unknown
  unsigned long blksize;   // the blocksize of the device
public:
  UnixDeviceInformer (const char* name) : UnixDeviceUser (name) {}
  
  bool detect ();
  void setup (unsigned long count, unsigned long block_size);

  unsigned long phys_size () { return size; }
  unsigned long phys_blocks () { return size / blksize; }
  unsigned long phys_block_size () { return blksize; }
};

#endif /* __Unix_Device_Informer_h__ */
