#ifndef __Unix_Device_Logic_h__
#define __Unix_Device_Logic_h__

#include "fs/device/UnixDeviceWorker.H"

// Here the UnixDeviceWorker class is extended by the ability to address
// logical blocks of arbitrary size. We achieve this by simply overwriting
// the device information. Unix can handle the necessary calculations.
// The default block size is used if you call detect () instead of 
// setup (unsigned long block_size).
class UnixDeviceLogic : public UnixDeviceWorker
{
public:
  UnixDeviceLogic (const char* name) : UnixDeviceWorker (name) {}
  void setup (unsigned long block_size);
};

#endif /* __Unix_Device_Logic_h__ */
