#ifndef __Unix_Device_Worker_Error_h__
#define __Unix_Device_Worker_Error_h__

#include "fs/device/UnixDeviceError.H"

// This class is used to store unix file device operation error codes and 
// allows to convert them into printable text.
// It extends UnixDeviceError so that also the logical errors of this
// system level can be described.
class UnixDeviceWorkerError : public UnixDeviceError
{
public:
  typedef enum Code { NO_ERROR, END_OF_FILE };
private:
  Code error_code;           // the error code
public:
  UnixDeviceWorkerError (Code e) : error_code(e) {}
  UnixDeviceWorkerError (UnixDeviceError e) : UnixDeviceError(e), error_code(NO_ERROR) {}

  operator const char * (); // return the string representation of the code
};

#endif /* __Unix_Device_Worker_Error_h__ */
