#ifndef __Block_Device_h__
#define __Block_Device_h__

#include "fs/device/block/BlockDeviceError.H"

// This class defines the standard interface for block oriented device.
// It contains standard data types and methods for synchronous i/o.
class BlockDevice
{
public:
  typedef unsigned long BlockNo;
  typedef unsigned long BlockCount;
  typedef unsigned long BlockSize;

  virtual ~BlockDevice () {}

  // select the preferred logical block size
  virtual BlockDeviceError setup (BlockSize block_size) = 0;

  // get device characteristics
  virtual BlockSize block_size () = 0;
  virtual BlockCount block_count () = 0;

  // read and write multiple blocks at once
  virtual BlockDeviceError read (BlockNo block, void* addr, BlockCount count) = 0;
  virtual BlockDeviceError write (BlockNo block, void* addr, BlockCount count) = 0;
};

#endif /* __Block_Device_h__ */
