#ifndef __Block_Device_Async_h__
#define __Block_Device_Async_h__

#include "fs/device/block/BlockDevice.H"
#include "fs/device/block/BlockDeviceAsyncHdl.H"

// This class defines the standard interface for block oriented device.
// It contains methods for asynchronous i/o.
class BlockDeviceAsync : public virtual BlockDevice
{
public:
  virtual ~BlockDeviceAsync() {}

  // read and write multiple blocks asynchronously
  virtual BlockDeviceError read_async(BlockDevice::BlockNo block, void* addr, BlockDevice::BlockCount count, BlockDeviceAsyncHdl* hdl) = 0;
  virtual BlockDeviceError write_async(BlockDevice::BlockNo block, void* addr, BlockDevice::BlockCount count, BlockDeviceAsyncHdl* hdl) = 0;
};

#endif /* __Block_Device_Async_h__ */
