#ifndef __Block_Device_Async_Executor_h__
#define __Block_Device_Async_Executor_h__

#include "fs/device/block/BlockDevice.H"
#include "fs/device/block/BlockDeviceAsyncHdl.H"

// This class implements the asynchronous execution of block device
// activties that exist in synchronous manner. A thread is created for
// the asynchronous task.
class BlockDeviceAsyncExecutor
{
  // The implementation uses a synchronous block device.
  BlockDevice* device;
public:
  // constructor: store the device address
  BlockDeviceAsyncExecutor (BlockDevice* dev) : device (dev) {}

  // read and write multiple blocks asynchronously for the given device
  BlockDeviceError read_async (BlockDevice::BlockNo block,  void* addr, BlockDevice::BlockCount count, BlockDeviceAsyncHdl* hdl);
  BlockDeviceError write_async (BlockDevice::BlockNo block, void* addr, BlockDevice::BlockCount count, BlockDeviceAsyncHdl* hdl);
};

#endif /* __Block_Device_Async_Executor_h__ */
