#ifndef __Block_Device_Async_Hdl_h__
#define __Block_Device_Async_Hdl_h__

#include "fs/device/block/BlockDevice.H"
#include "system/AsyncOperationHdl.H"

class BlockDeviceAsyncExecutor; 

// This class is used for the asynchronous execution of unix file device
// activities. It is a per-activity context storage and a handle for the
// synchronization with the asynchronous activity.
class BlockDeviceAsyncHdl : public AsyncOperationHdl
{
private:
  friend class BlockDeviceAsyncExecutor; // allow manipulation only by friend

  enum { UNKNOWN, READ, WRITE } opcode;
  BlockDevice::BlockNo block;
  void* addr;
  BlockDevice::BlockCount count;
  BlockDevice* dev;
  BlockDeviceError error_code;
protected:
  void action ();
public:
  BlockDeviceAsyncHdl () : opcode (UNKNOWN) {} 
  BlockDeviceError error () { return error_code; }
};

#endif /* __Block_Device_Async_Hdl_h__ */
