#include "CommandLine.H"

#include <string.h>

#include "commands/CommandExit.H"
#include "commands/CommandHelp.H"

CommandLine::CommandLine() : _exit(false), _bufferpos(0) {}

void CommandLine::Execute(int argc, char *argv[]) 
{
  if (strcmp(argv[0], "exit") == 0) {
    CommandExit cmd_exit(this);
    cmd_exit.Execute(argc, argv);
    return;
  }
  //TODO insert sourcecode
  
  CommandHelp cmd_help(this);
  cmd_help.Execute(argc, argv);
}

void CommandLine::Message(char input)
{
  switch(input) 
  {
	  case '\n':
	    _buffer[_bufferpos] = '\0';
	    Parse();
	    break;
	  case EOF:
	    _exit = true;
	    break;
	  default:
	    _buffer[_bufferpos++] = input;
	    break;
  }
}

void CommandLine::Parse() 
{
  argc    = 1;
  argv[0] = _buffer;
    
  Execute(argc, argv);
  if (!_exit) {
    printf("prompt>");
    _bufferpos = 0;
  }
}

