#include "fs/FSFile.H"
#include "fs/FSFileImpl.H"

FSResult FSFile::read (void* buffer, FS::Count buffer_size, FS::Pos pos, FS::Count &really_transfered)
{
  FSResult result;

  if ((result = check_impl ()))
    result = impl_file ()->read (buffer, buffer_size, pos, really_transfered);
  return result;
}

FSResult FSFile::write (void* buffer, FS::Count bytes_to_write, FS::Pos pos)
{
  FSResult result;

  if ((result = check_impl ()))
    result = impl_file ()->write (buffer, bytes_to_write, pos);
  return result;
}
 
FSResult FSFile::trunc (FS::Pos pos)
{
  FSResult result;

  if ((result = check_impl ()))
    result = impl_file ()->trunc (pos);
  return result;
}
