#include "fs/device/UnixDeviceInformer.H"

#include <sys/stat.h>
#include <unistd.h>
#include <iostream>


bool UnixDeviceInformer::detect ()
 {
   struct stat st;

   if (fstat (handle (), &st) != 0)
      return false;

   blksize = st.st_blksize;
   size    = st.st_size;

   return true;
 }


void UnixDeviceInformer::setup (unsigned long count, unsigned long block_size)
 {
   blksize  = block_size;
   size     = count * block_size;
 }
