#include "fs/device/block/BlockDeviceAsyncExecutor.H"
#include "fs/device/block/BlockDeviceAsyncHdl.H"

// read and write multiple blocks at once

BlockDeviceError BlockDeviceAsyncExecutor::read_async (
   BlockDevice::BlockNo block,
   void* addr, 
   BlockDevice::BlockCount count,
   BlockDeviceAsyncHdl* hdl)
 {
   const char* msg = (const char*)0;

   hdl->opcode = BlockDeviceAsyncHdl::READ;
   hdl->block  = block;
   hdl->addr   = addr;
   hdl->count  = count;
   hdl->dev    = device;

   // now start the thread
   if (!hdl->execute ())
      msg = "cannot start asynchronous read";

   return msg;
 }


BlockDeviceError BlockDeviceAsyncExecutor::write_async (
   BlockDevice::BlockNo block,
   void* addr, 
   BlockDevice::BlockCount count,
   BlockDeviceAsyncHdl* hdl)
 {
   const char* msg = (const char*)0;

   hdl->opcode = BlockDeviceAsyncHdl::WRITE;
   hdl->block  = block;
   hdl->addr   = addr;
   hdl->count  = count;
   hdl->dev    = device;

   // now start the thread
   if (!hdl->execute ())
      msg = "cannot start asynchronous write";

   return msg;
 }

