#include "system/AsyncOperationHdl.H"
#include <pthread.h>

// entry point for the posix thread. "arg" is the OperationHdl itself.
void* AsyncOperationHdl::thread_entry (void* arg)
{
  AsyncOperationHdl *this_pointer;

  this_pointer = (AsyncOperationHdl*)arg;
  this_pointer->action ();
  this_pointer->done ();
  return (void*)0;
}


// start the asynchronous activity.
bool AsyncOperationHdl::execute ()
{
  pthread_t thread;
  bool success;
   
  success = (pthread_create (&thread, NULL, thread_entry, this) == 0);
  if (success)
    pthread_detach(thread);

  return success;
}

